<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaskSearchRow StructType
 * @subpackage Structs
 */
class TaskSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TaskSearchRowBasic
     */
    public $basic;
    /**
     * The assignedJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $assignedJoin;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchRowBasic
     */
    public $caseJoin;
    /**
     * The companyCustomerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $companyCustomerJoin;
    /**
     * The contactJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchRowBasic
     */
    public $contactJoin;
    /**
     * The employeeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $employeeJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The jobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $jobJoin;
    /**
     * The opportunityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpportunitySearchRowBasic
     */
    public $opportunityJoin;
    /**
     * The originatingLeadJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OriginatingLeadSearchRowBasic
     */
    public $originatingLeadJoin;
    /**
     * The timeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TimeBillSearchRowBasic
     */
    public $timeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for TaskSearchRow
     * @uses TaskSearchRow::setBasic()
     * @uses TaskSearchRow::setAssignedJoin()
     * @uses TaskSearchRow::setCaseJoin()
     * @uses TaskSearchRow::setCompanyCustomerJoin()
     * @uses TaskSearchRow::setContactJoin()
     * @uses TaskSearchRow::setEmployeeJoin()
     * @uses TaskSearchRow::setFileJoin()
     * @uses TaskSearchRow::setJobJoin()
     * @uses TaskSearchRow::setOpportunityJoin()
     * @uses TaskSearchRow::setOriginatingLeadJoin()
     * @uses TaskSearchRow::setTimeJoin()
     * @uses TaskSearchRow::setTransactionJoin()
     * @uses TaskSearchRow::setUserJoin()
     * @uses TaskSearchRow::setUserNotesJoin()
     * @uses TaskSearchRow::setCustomSearchJoin()
     * @param \StructType\TaskSearchRowBasic $basic
     * @param \StructType\EmployeeSearchRowBasic $assignedJoin
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @param \StructType\CustomerSearchRowBasic $companyCustomerJoin
     * @param \StructType\ContactSearchRowBasic $contactJoin
     * @param \StructType\EmployeeSearchRowBasic $employeeJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\TaskSearchRowBasic $basic = null, \StructType\EmployeeSearchRowBasic $assignedJoin = null, \StructType\SupportCaseSearchRowBasic $caseJoin = null, \StructType\CustomerSearchRowBasic $companyCustomerJoin = null, \StructType\ContactSearchRowBasic $contactJoin = null, \StructType\EmployeeSearchRowBasic $employeeJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\JobSearchRowBasic $jobJoin = null, \StructType\OpportunitySearchRowBasic $opportunityJoin = null, \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null, \StructType\TimeBillSearchRowBasic $timeJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAssignedJoin($assignedJoin)
            ->setCaseJoin($caseJoin)
            ->setCompanyCustomerJoin($companyCustomerJoin)
            ->setContactJoin($contactJoin)
            ->setEmployeeJoin($employeeJoin)
            ->setFileJoin($fileJoin)
            ->setJobJoin($jobJoin)
            ->setOpportunityJoin($opportunityJoin)
            ->setOriginatingLeadJoin($originatingLeadJoin)
            ->setTimeJoin($timeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\TaskSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\TaskSearchRowBasic $basic
     * @return \StructType\TaskSearchRow
     */
    public function setBasic(\StructType\TaskSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get assignedJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getAssignedJoin()
    {
        return $this->assignedJoin;
    }
    /**
     * Set assignedJoin value
     * @param \StructType\EmployeeSearchRowBasic $assignedJoin
     * @return \StructType\TaskSearchRow
     */
    public function setAssignedJoin(\StructType\EmployeeSearchRowBasic $assignedJoin = null)
    {
        $this->assignedJoin = $assignedJoin;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchRowBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @return \StructType\TaskSearchRow
     */
    public function setCaseJoin(\StructType\SupportCaseSearchRowBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get companyCustomerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCompanyCustomerJoin()
    {
        return $this->companyCustomerJoin;
    }
    /**
     * Set companyCustomerJoin value
     * @param \StructType\CustomerSearchRowBasic $companyCustomerJoin
     * @return \StructType\TaskSearchRow
     */
    public function setCompanyCustomerJoin(\StructType\CustomerSearchRowBasic $companyCustomerJoin = null)
    {
        $this->companyCustomerJoin = $companyCustomerJoin;
        return $this;
    }
    /**
     * Get contactJoin value
     * @return \StructType\ContactSearchRowBasic|null
     */
    public function getContactJoin()
    {
        return $this->contactJoin;
    }
    /**
     * Set contactJoin value
     * @param \StructType\ContactSearchRowBasic $contactJoin
     * @return \StructType\TaskSearchRow
     */
    public function setContactJoin(\StructType\ContactSearchRowBasic $contactJoin = null)
    {
        $this->contactJoin = $contactJoin;
        return $this;
    }
    /**
     * Get employeeJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getEmployeeJoin()
    {
        return $this->employeeJoin;
    }
    /**
     * Set employeeJoin value
     * @param \StructType\EmployeeSearchRowBasic $employeeJoin
     * @return \StructType\TaskSearchRow
     */
    public function setEmployeeJoin(\StructType\EmployeeSearchRowBasic $employeeJoin = null)
    {
        $this->employeeJoin = $employeeJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\TaskSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get jobJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getJobJoin()
    {
        return $this->jobJoin;
    }
    /**
     * Set jobJoin value
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @return \StructType\TaskSearchRow
     */
    public function setJobJoin(\StructType\JobSearchRowBasic $jobJoin = null)
    {
        $this->jobJoin = $jobJoin;
        return $this;
    }
    /**
     * Get opportunityJoin value
     * @return \StructType\OpportunitySearchRowBasic|null
     */
    public function getOpportunityJoin()
    {
        return $this->opportunityJoin;
    }
    /**
     * Set opportunityJoin value
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @return \StructType\TaskSearchRow
     */
    public function setOpportunityJoin(\StructType\OpportunitySearchRowBasic $opportunityJoin = null)
    {
        $this->opportunityJoin = $opportunityJoin;
        return $this;
    }
    /**
     * Get originatingLeadJoin value
     * @return \StructType\OriginatingLeadSearchRowBasic|null
     */
    public function getOriginatingLeadJoin()
    {
        return $this->originatingLeadJoin;
    }
    /**
     * Set originatingLeadJoin value
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @return \StructType\TaskSearchRow
     */
    public function setOriginatingLeadJoin(\StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null)
    {
        $this->originatingLeadJoin = $originatingLeadJoin;
        return $this;
    }
    /**
     * Get timeJoin value
     * @return \StructType\TimeBillSearchRowBasic|null
     */
    public function getTimeJoin()
    {
        return $this->timeJoin;
    }
    /**
     * Set timeJoin value
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @return \StructType\TaskSearchRow
     */
    public function setTimeJoin(\StructType\TimeBillSearchRowBasic $timeJoin = null)
    {
        $this->timeJoin = $timeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\TaskSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\TaskSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\TaskSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $taskSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$taskSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($taskSearchRowCustomSearchJoinItem) ? get_class($taskSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($taskSearchRowCustomSearchJoinItem), var_export($taskSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\TaskSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\TaskSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
